#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <string.h>
#include <netdb.h>
#include <stdio.h>

#define BUFLEN 8192
#define PORT 6789

main(int argc, char *argv[])
/*
**   Listing5.1a.c - rcat: lists the contents of a remote file
*/
{
   struct sockaddr_in sock;
   struct hostent *hp;
   int port = PORT;
   int fd, ii;
   char buffer[BUFLEN];
   char *p;

   /* argv[] */
   if(argc < 2)
   {
      printf("\n\tUsage: %s <IP_Addr>:<file_name>\n\n", argv[0]);
      exit(-1);
   }

   /* isolate remote host from file */
   if((p=strchr(argv[1], ':')) == NULL)
   {
      printf("\n\tUsage: %s <IP_Addr>:<file_name>\n\n", argv[0]);
      exit(-1);
   }
   *p = '\0';
   p++; /* reset to file */
   
   /* get vitals regarding remote server */
   strncpy(buffer, argv[1], sizeof(buffer));
   hp = gethostbyname(buffer);

   /* initialize the TCP stream socket structure */
   fd = socket(AF_INET, SOCK_STREAM, 0);
   memset((char *) &sock, 0, sizeof(sock));
   memcpy(&sock.sin_addr, hp->h_addr, hp->h_length);
   sock.sin_family = hp->h_addrtype;
   sock.sin_port = htons(port);

   /* connect to the remote server */
   connect(fd, (struct sockaddr *) &sock, sizeof(sock));

   /* send the file name to the service */
   strncpy(buffer, p, sizeof(buffer));
   send(fd, buffer, strlen(buffer)+1, 0);

   /*
   **   Print remote file contents to screen
   */
   while(1)
   {
      if((ii = recv(fd, buffer, sizeof(buffer), 0)) < 0)
      {
         perror("Listing5.1a: recv()");
         close(fd);
         exit(-1);
      }
      else if(ii > 0) /* good packet received */
      {
         p = buffer;
         while(ii) /* process all input lines */
         {
            /* print each new line till DONE */
            if(strncmp(p, "DONE", 4) == 0)
               break;
            else
               printf("Listing5.1a: '%s'\n", p);

            /* subsequent lines */
            ii -= (strlen(p) + 1);
            p += strlen(p) + 1;
         }
      }
      else /* socket connection was closed */
         break;
   }
   close(fd);
   return(0);
}
